#include "../header.h"
#include "../lib/functions.cpp"

void Cmd::Explode(std::string command) {

  this->argc=new int;
  int found=0;
  *(this->argc)=1;
  found=(int)command.find(" ");
  if(found!=-1) {++(*(this->argc));}
  while (found!=-1)
  {
    found=command.find_first_of(" ",found+1);
    if(found!=-1) ++(*(this->argc));
  }
  this->argv=new char*[*(this->argc)];
  std::string dummies[*(this->argc)];
  
  int i=0;
  if(*(this->argc)!=1) {  
    while((int)command.find(" ")!=-1) {
      dummies[i]=command.substr(0,(int)command.find(" "));
      this->argv[i]=(char*)malloc(sizeof(char)*(dummies[i].length()+1));
      strcpy(this->argv[i],dummies[i].c_str());
      ++i; 
      command.erase(0,(int)command.find(" ")+1);
    }
    dummies[i]=command;
    this->argv[i]=(char*)malloc(sizeof(char)*(dummies[i].length()+1));
    strcpy(this->argv[i],dummies[i].c_str());  
  }
  else {
    dummies[0]=command;
    this->argv[0]=(char*)malloc(sizeof(char)*(dummies[0].length()+1));
    strcpy(this->argv[0],dummies[0].c_str());
  }
  
}  /*Command*/

void Cmd::FileHandling(std::string type) {

  if(type=="read") {
    std::string dummy;
    FuncTable dummy_func; 
    std::ifstream fin; 
    fin.open("./cmd/options/lang");
    if(fin.fail()) {
      std::cout << "Error reading ./cmd/options/lang" << std::endl;
      std::exit(1);
    }
    getline(fin,*(this->lang));
    fin.close();
    dummy="./cmd/lang/"; dummy+=*(this->lang); dummy+="/error";
    fin.open(dummy.c_str());
    if(fin.fail()) {
      std::cout << "Error reading" << dummy << std::endl;
      std::exit(1);
    }
    while(getline(fin,dummy)) {
     (*(this->error)).push_back(dummy);
    }
    fin.close();
    dummy="./cmd/lang/"; dummy+=*(this->lang); dummy+="/header";
    fin.open(dummy.c_str());
    if(fin.fail()) {
      printf((*(this->error))[0].c_str(),(*(this->lang)).c_str());
      std::exit(1);
    }
    while(getline(fin,dummy)) {
      dummy+="\n";
      *(this->header)+=dummy;
    }
    fin.close();
    dummy="./cmd/lang/"; dummy+=*(this->lang); dummy+="/functions";
	fin.open(dummy.c_str());
	if(fin.fail()) {
	    printf((*(this->error))[1].c_str(),(*(this->lang)).c_str());
      std::exit(1); 
    }
    while(!fin.eof()) {
      fin >> dummy_func.name;
      fin >> dummy_func.id;
      (*(this->functions)).push_back(dummy_func);
    }
    fin.close();
  }
  else {
  }

}  /*Cmd::FileHandling*/

void Cmd::Header() {

  std::cout << *(this->header);
  delete header;

}  /*Cmd::Header*/

void Cmd::Do(int funct_id) {

  switch(funct_id) {
  
    case 0: { Exit(); break; }
    case 1: { Commands(*(this->functions)); break; }
    case 2: { Echo(*(this->argc),this->argv); break; }
    
  }
  
}  /*Cmd::Do*/

Cmd::Cmd() {
	
  system("clear");
  lang = new std::string;
  error = new std::vector<std::string>;
  header = new std::string;
  command = new std::string;
  functions = new std::vector<FuncTable>;
  this->FileHandling("read");
  this->Header();

}  /*Cmd::Cmd*/

Cmd::~Cmd() {

  delete lang;
  delete error;
  //delete header; //deleted in Cmd::Header()
  delete command;
  delete functions;

}  /*Cmd::~Cmd*/

void Cmd::ReadLine() {
  
  std::cout << ">";
  getline(std::cin,*(this->command),'\n');

}  /*Cmd::ReadLine*/

void Cmd::Eval() {

  int i=0;
  bool van = false;
  this->Explode(*(this->command));
  while(i<(int)(*(this->functions)).size() && van==false) {
    if((*(this->functions))[i].name==this->argv[0]) {
      van=true;
      Do((*(this->functions))[i].id);
    }
    ++i;
  }
  if(!van) { std::cout << (*(this->error))[2] << std::endl; }
  for(int i=1;i<*(this->argc);++i) {
    delete [] this->argv[i];
  }
  delete argv;
  delete argc;
  
}  /*Cmd::Eval*/
